'MathForKids by Charles Dietz
'ver 1.00 07/30/2009
'ver 1.10 08/02/2009
' - added progress bar for time
' - added mix of math functions
'ver 1.20 08/07/2009
' - changed from two modes to three (Learn, Drill, & Test)
' - redefined Learn mode (learn math tables one number at a time)
' - added myMsgbox for correcting wrong answers
'ver 1.21 08/07/2009
' - fixed inf loop from changing test mode to learn or drill (added startTime = 0)
'ver 1.22 08/09/2009
' - applied new way to handle GUI initializations (greeting)
' - retained correct out of total for all three modes
' - corrected the learning mode division (set of numbers used for the problems)
'ver 1.23 08/11/2009
' - answer is not evaluated for Spacebar or when unanswered (Learn/Drill mode)
' - added results dialog with listbox of mistakes
'ver 1.24 08/12/2009
' - added answer textbox to listbox of mistakes
'ver 1.25 08/13/2009
' - added mix column to report
' - fixed various bugs related to saveData and config
'ver 1.30 08/18/2009
' - refined random problem picks to exclude already selected ones
'   (more nearly simulates flash cards by shuffling them)
'ver 1.31 08/23/2009
' - fixed some minor navigation problems
' - eliminated %BS_TABSTOP style
'ver 1.32 08/28/2009
' - fixed some minor paint problems (residuals left by blinking cursor)
' - changed textbox to combobox in learn dialog (for specifying numLearn)
'ver 1.33 09/02/2009
' - added keyboardHook to better capture ENTER key
' - added WS_TABSTOP styles to toolbar buttons to allow TABs with ENTER
' - added WM_TIMER message with SetTimer (able to make hMain MODAL)
'ver 1.34 09/03/2009
' - reverted back to ACCEL keys rather than keyboardHook (avoid non numeral errors)
' - assigned accel keys with SUB assignAccl()
'ver 1.35 09/06/2009
' - added checkbox in Learn dialog to show all answers
' - corrected status line for correct/total
'ver 1.36 09/07/2009
' - added help(F1) to greeting dialog plus instructions to begin program
' - version now appears in title of greeting dialog (not help file)
' - corrected config dialog to show initial values and improved Learn dialog code
'ver 1.37 09/08/2009
' - changed instruction labels (lower right corner) to buttons
' - corrected value of numLearn when changing math function in Learn dialog
'ver 1.38 09/10/2009
' - corrected a GPF dimension error in build()
' - improved card deck, allowing (i op j) and (j op i)
'ver 1.40 10/01/2009, compiler 9.01
' - replaced "happyFace.bmp" with "happyFace.ico to reduce exe size
'ver 1.41 10/12/2009, compiler 9.02
' - replaced IsFile(dataFolder) with folderExists()... compiler 9.02 changed
'ver 1.50 11/11/2009
' - added two more test options - print test pages and save test scores
'ver 1.52 03/07/2010
' - added minimum number to number range in config()
' - revised buildDeck() routine to reflect new number range
' - improved algorithm in buildDeck() by excluding both [a,b] and [b,a] cards
'ver 1.53 05/24/2010
' - changed data storage from _DOCUMENTS to _APPDATA
'ver 1.60 01/20/2011    
' - allow space bar answers with the drill mode
' - allow printing of test page with add, sub, mul, and div on front side - no duplex
' - allow printing of test page with combination of all four functions on front side only
'ver 1.70 01/11/2011
' - corrected multiple printed copies
'ver 1.80 03/10/2018
' - completely updated Print Test Page feature
' - corrected multiple pages printed
' - Test ID automatically incremented for reprinting test later
'ver 1.90 09/15/2020
' - corrected range of drill numbers, to include both (n1 op n2) and (n2 op n1)
' - improved showing correct answers when wrong and showing happy face when right                          
' - correction: number of problems for test mode on computer is dependent on time and probsPerMin
' - added timed flash cards for verbal drill as a new feature
'==================================================================================================

%IDC_Number1     = 101
%IDC_Number2     = 102
%IDC_Op          = 103                              
%IDC_Eq          = 104
%IDC_Answer      = 105
%IDC_myAnswer    = 106
%IDC_Instr1      = 107
%IDC_Instr2      = 108
%IDC_StatLine1   = 109
%IDC_StatLine2   = 110
%IDC_AnsAll      = 111
%IDC_HappyFace   = 112
%IDC_Return      = 113
%IDC_Space       = 114

%IDC_Toolbar     = 200
%IDC_LearnBtn    = 201
%IDC_DrillBtn    = 202
%IDC_TestBtn     = 203
%IDC_ReptBtn     = 204
%IDC_ConfBtn     = 205
%IDC_QuitBtn     = 206
%IDC_HelpBtn     = 207
%IDC_EscBtn      = 208
%IDC_GreetHelp   = 209

%IDC_CompuTest   = 221
%IDC_PrintTest   = 222
%IDC_ReptScore   = 223

%IDC_TestID      = 231
%IDC_NumCopies   = 232
%IDC_ProbTypes   = 233
%IDC_InclAns     = 234
%IDC_TestDate    = 235

%IDC_ListNames   = 250
%IDC_Name        = 251

%IDC_Next        = 301
%IDC_Ans         = 302
%IDC_NumProbs1   = 311
%IDC_minNum1     = 312
%IDC_maxNum1     = 313
%IDC_NumProbs2   = 314
%IDC_minNum2     = 315
%IDC_maxNum2     = 316
%IDC_NumLearn    = 317
%IDC_TestTime    = 321
%IDC_Remark      = 322
%IDC_Problems    = 323
%IDC_TestProbs   = 324
%IDC_DataLoc     = 325
%IDC_Report      = 326
%IDC_Percent     = 327
%IDC_Ratio       = 328
%IDC_TimeLeft    = 329
%IDC_Mistakes    = 330
%IDC_Correct     = 331
%IDC_CorrectAns  = 332

%IDC_TestAdd     = 341
%IDC_TestSub     = 342
%IDC_TestMul     = 343
%IDC_TestDiv     = 344
%IDC_MixAll      = 345
%IDC_AddSub      = 346
%IDC_MulDiv      = 347
%IDC_FlashCards  = 351
%IDC_Timer       = 352
%IDC_HelpTxt     = 353

%IDM_About       = 900
'%my_SHOWWINDOW   = 999

TYPE testDataType '8 bytes per record
   Date      AS INTEGER
   mathOp    AS BYTE
   Time      AS BYTE
   total     AS INTEGER
   correct   AS INTEGER                               
END TYPE

GLOBAL hMain, showAllAnswers AS LONG
GLOBAL maxNum1, maxNum2, minNum1, minNum2, probsPerMin1, probsPerMin2 AS LONG
GLOBAL ZmaxNum1, ZmaxNum2, ZprobsPerMin1, ZprobsPerMin2, ZfileChanged AS LONG
GLOBAL fileChanged, minNum, maxNum, mathOp, init, nCards, iniFileChanged AS LONG
GLOBAL numTests, numNames, numProbs, correct, testID, saveID, flashCards AS LONG
GLOBAL testTime, maxTime, timeUp, nMode, numLearn, wrongAns AS LONG
GLOBAL lastOp, lastNumLearned, lastTestType, myMsgboxReturn AS LONG    
GLOBAL myName, fmt, dataFolder, dataFile, iniFile, helpFile AS STRING
GLOBAL startTime AS DOUBLE
GLOBAL nameList(), timeList(), arith(), mistakes(), cards(), correctAns() AS STRING
GLOBAL testData() AS testDataType

DECLARE FUNCTION HtmlHelp LIB "hhctrl.ocx" ALIAS "HtmlHelpA" _
          (BYVAL LONG, ASCIIZ, BYVAL LONG, BYVAL LONG ) AS LONG

                                                                          
'Notes:
'cards() = str$(num1), str$(num2), mathOp  (s1 op s2 = s3)
'DIM cards((n + 1) * n)
'for n = 12:  DIM cards(156)
'n = 156
'WHILE n
'   j = RND(1, n): SWAP cards(j, n): DECR n
'WEND
