#COMPILE EXE                                                                      
#DIM ALL                                         
'#debug display on                                                                                                       
'#INCLUDE "win32api.inc"                                             
'#INCLUDE "ComDlg32.Inc"
#INCLUDE "MathForKids.inc"             
#INCLUDE "TPrint.inc"                                                    
#include "appHelp.inc"
'#INCLUDE "debug.inc"          
#RESOURCE "MathForKids.pbr"
                         
$verNo = "1.90"                                    
                                                                 
FUNCTION PBMAIN()                                                                                  
   LOCAL ti AS STRING                                      
   LOCAL nStyle, wi, ht, h AS LONG
   ti = "Math for Kids"
   wi = 640: ht = 400: h = 120                                                                
   DIALOG FONT "MS Sans Serif", 10
   DIALOG NEW PIXELS, 0, ti, , , wi, ht, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hMain
   nStyle = %SS_GRAYRECT + %SS_BLACKFRAME
   CONTROL ADD LINE, hMain, %IDC_Toolbar, "", 0, 0, wi - 2, 30, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hMain, %IDC_LearnBtn, "&Learn", 2, 2, 80, 25, %WS_TABSTOP
   CONTROL ADD BUTTON, hMain, %IDC_DrillBtn, "&Drill", 82, 2, 80, 25, %WS_TABSTOP
   CONTROL ADD BUTTON, hMain, %IDC_TestBtn, "&Test", 162, 2, 80, 25, %WS_TABSTOP
   CONTROL ADD BUTTON, hMain, %IDC_ReptBtn, "&Report", 280, 2, 80, 25, %WS_TABSTOP
   CONTROL ADD BUTTON, hMain, %IDC_ConfBtn, "&Config", 360, 2, 80, 25, %WS_TABSTOP
   CONTROL ADD BUTTON, hMain, %IDC_QuitBtn, "&Quit", 440, 2, 80, 25, %WS_TABSTOP
   CONTROL ADD BUTTON, hMain, %IDC_HelpBtn, "&Help", wi - 82, 2, 80, 25, %WS_TABSTOP

   CONTROL ADD LABEL, hMain, %IDC_Number1, "", 30, h, 100, 60, %SS_CENTER OR %WS_GROUP
   CONTROL ADD LABEL, hMain, %IDC_Op, "", 150, h, 60, 60, %SS_CENTER
   CONTROL ADD LABEL, hMain, %IDC_Number2, "", 230, h, 100, 60, %SS_CENTER
   CONTROL ADD LABEL, hMain, %IDC_Eq, "", 350, h, 60, 60, %SS_CENTER
   CONTROL ADD LABEL, hMain, %IDC_Answer, "", 460, h, 160, 60, %SS_LEFT
   CONTROL ADD BUTTON, hMain, %IDC_Instr1, "", wi - 200, ht - 80, 180, 30
   CONTROL ADD BUTTON, hMain, %IDC_Instr2, "", wi - 200, ht - 40, 180, 30
   CONTROL ADD LABEL, hMain, %IDC_StatLine1, "", 20, ht - 55, 180, 20
   CONTROL ADD LABEL, hMain, %IDC_StatLine2, "", 20, ht - 30, 250, 20
   nStyle = %WS_TABSTOP OR %ES_NUMBER                                       
   CONTROL ADD TEXTBOX, hMain, %IDC_myAnswer, "", 460, h, 160, 60, nStyle
   CONTROL ADD IMAGEX, hMain, %IDC_HappyFace, "happy", 60, ht - 140, 70, 60
   CONTROL SHOW STATE hMain, %IDC_Instr1, %SW_HIDE
   CONTROL SHOW STATE hMain, %IDC_Instr2, %SW_HIDE
   CONTROL SHOW STATE hMain, %IDC_myAnswer, %SW_HIDE
   CONTROL SHOW STATE hMain, %IDC_HappyFace, %SW_HIDE
   DIALOG SHOW MODAL hMain CALL mainProc
END FUNCTION

CALLBACK FUNCTION mainProc() 
   LOCAL s, f AS STRING
   LOCAL hFontProb, hFontInstr, hAccel AS LONG               
   LOCAL i, k, n, nStyle, hFile, ZfileChanged AS LONG                                                              
   STATIC number1, number2, done, hBrush, hdc AS LONG
   STATIC probNo, probs, answer, x0, y0, nMax AS LONG
   STATIC myAnswer, op AS STRING
   STATIC rc AS RECT
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         DIALOG SET COLOR CB.HNDL, %BLACK, %WHITE               
         FOR i = 101 TO 110
            CONTROL SET COLOR CB.HNDL, i, %BLACK, %WHITE
         NEXT i
         FONT NEW "FontProb", 40, 1 TO hFontProb
         FONT NEW "FontInstr", 15, 3 TO hFontInstr
         FOR i = 101 TO 106
            CONTROL SET FONT CB.HNDL, i, hFontProb        
         NEXT i
         CONTROL SET FONT CB.HNDL, %IDC_Instr1, hFontInstr
         CONTROL SET FONT CB.HNDL, %IDC_Instr2, hFontInstr
         CONTROL SET FOCUS CB.HNDL, %IDC_Answer

         DIM ac(1 TO 11) AS ACCELAPI
         assignAccl ac(1), %VK_RETURN, %IDC_Return
         assignAccl ac(2), %VK_SPACE, %IDC_Space
         assignAccl ac(3), %VK_L, %IDC_LearnBtn
         assignAccl ac(4), %VK_D, %IDC_DrillBtn
         assignAccl ac(5), %VK_T, %IDC_TestBtn
         assignAccl ac(6), %VK_R, %IDC_ReptBtn
         assignAccl ac(7), %VK_C, %IDC_ConfBtn
         assignAccl ac(8), %VK_Q, %IDC_QuitBtn
         assignAccl ac(9), %VK_H, %IDC_HelpBtn
         assignAccl ac(10), %VK_ESCAPE, %IDC_EscBtn
         assignAccl ac(11), %VK_F1, %IDC_HelpBtn
         ACCEL ATTACH CBHNDL, ac() TO hAccel

         dataFolder = specialFolder(%CSIDL_COMMON_APPDATA)
         IF LEN(dataFolder) = 0 THEN dataFolder = "C:\My Documents"
         dataFolder = dataFolder + "\cgdSoftware\MathForKids" 
         if isfolder(dataFolder) then
            f = DIR$(dataFolder + "\*.mfk")
            WHILE LEN(f) 'find number of mfk files in dataFolder
               INCR numNames: REDIM PRESERVE nameList(1 TO numNames)
               n = INSTR(f, "."): f = LEFT$(f, n - 1)
               nameList(numNames) = f:
               f = DIR$(NEXT)
            WEND
         else
            mkdir(dataFolder)
         end if
         'for i = 1 to numNames: debug nameList(i): next i
         
         iniFile = dataFolder + "\mathForKids.ini" 
         if isfile(iniFile) then
            hFile = FREEFILE
            OPEN iniFile FOR input AS hFile
               input# hFile, saveID                                                    
            close #hFile
         else
            testID = 0   
            hFile = FREEFILE
            OPEN iniFile FOR output AS hFile
               print# hFile, saveID
            close #hFile                    
            iniFileChanged = 1
         end if
         
         helpFile = dataFolder + "\mathForKids.ahp"
         if isfile(helpFile) = 0 then 
            msgbox "Help is unavailable", %MB_iconerror, "Helpfile not found"
         end if                                                                                   
         dim arith(1 to 7) 
         array assign arith() = "Add", "Sub", "Mult", "Div", "Mixed", "Add/Sub", "Mult/Div"
         REDIM testData(1000)
         
         fmt = "0.00"                                       
         rc.nLeft = 460: rc.nTop = 120: rc.nRight = 620: rc.nBottom = 200
         hBrush = CreateSolidBrush(%WHITE)
         hdc = GetDC(CB.HNDL)
         nStyle = %PBS_SMOOTH OR %WS_BORDER

         DIALOG GET LOC CB.HNDL TO x0, y0
         DIALOG POST CBHNDL, %WM_USER + 100, 0, 0  'for GUI initializations

      CASE %WM_USER + 100  'GUI initializations
         clearWindow: testTime = 0: startTime = 0: mathOp = 0: op = "": nMode = 0
         greeting
         'CONTROL SEND CB.HNDL, %IDC_LearnBtn, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE 
         'msgbox "here"
      CASE %WM_COMMAND
         IF CB.CTL > %IDC_Toolbar AND CB.CTL < %IDC_QuitBtn THEN
            IF CB.CTL = %IDC_TestBtn THEN
               CONTROL SET SIZE CB.HNDL, %IDC_StatLine1, 30, 20
            ELSEIF CB.CTL < %IDC_TestBtn THEN
               CONTROL SET SIZE CB.HNDL, %IDC_StatLine1, 180, 20
            END IF
            clearWindow: testTime = 0: startTime = 0: mathOp = 0: op = "": nMode = 0
         END IF
         SELECT CASE CB.CTL
            'msgbox "here   "+str$(cb.ctl)   
            CASE %IDC_Return 'process return key 
               control get text cb.hndl, %IDC_Instr1 to s
               if s = "Stop" then
                  clearWindow: testTime = 0: startTime = 0: mathOp = 0: op = "": nMode = 0: exit function
               end if              
               k = GetDlgCtrlID(GetFocus)
               FOR i = 1 TO 7
                  IF (nMode = 0 OR probNo) AND k = %IDC_Toolbar + i THEN
                     n = %IDC_Toolbar + i: DIALOG SEND CB.HNDL, %WM_COMMAND, n, 0: EXIT FOR
                  END IF
               NEXT i
               IF n = 0 THEN DIALOG SEND CB.HNDL, %WM_COMMAND, %IDC_Next, 0
               CONTROL SEND CB.HNDL, n, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
            CASE %IDC_Space
               IF LEN(myAnswer) = 0 THEN
                  CONTROL GET TEXT CB.HNDL, %IDC_Answer TO s
                  IF LEN(s) THEN EXIT FUNCTION
                  DIALOG SEND CB.HNDL, %WM_COMMAND, %IDC_Ans, 0
                  CONTROL SHOW STATE CB.HNDL, CB.CTL, %SW_HIDE
               END IF
            CASE %IDC_EscBtn
               clearWindow: testTime = 0: startTime = 0: mathOp = 0: op = "": nMode = 0
               CONTROL SET FOCUS CB.HNDL, %IDC_LearnBtn
               CONTROL SEND CB.HNDL, %IDC_LearnBtn, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
            CASE %IDC_LearnBtn
               msgbox "here 2"
               flashCards = 0: CONTROL enable cb.hndl, %IDC_myAnswer
               clearWindow: nMode = 1: Learn
            CASE %IDC_DrillBtn                    
               redim timeList(1 to 10)
               array assign timeList() = "1", "2", "3", "4", "5", "6", "7", "8", "9", "10"
               flashCards = 0: CONTROL enable cb.hndl, %IDC_myAnswer
               clearWindow: nMode = 2: Drill
            CASE %IDC_TestBtn
               reDIM timeList(1 to 15)
               array assign timeList() = "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "12", "15", "20", "25", "30"
               flashCards = 0: CONTROL enable cb.hndl, %IDC_myAnswer
               clearWindow: testJob
            CASE %IDC_ReptBtn
               report
            CASE %IDC_ConfBtn
               config
            CASE %IDC_QuitBtn
               DIALOG SEND CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
            CASE %IDC_HelpBtn
               'CONTROL SET FOCUS CB.HNDL, %IDC_Answer              
               appHelp helpFile, "Math for Kids help"
            CASE %IDC_myAnswer 'evaluate answer and show happy face if correct
               IF CB.CTLMSG = %EN_CHANGE THEN 'correct or wrong
                  IF mathOp = 1 THEN answer = number1 + number2
                  IF mathOp = 2 THEN answer = number1 - number2
                  IF mathOp = 3 THEN answer = number1 * number2                                     
                  IF mathOp = 4 THEN answer = number1 / number2
                  CONTROL GET TEXT CB.HNDL, %IDC_myAnswer TO myAnswer                           
                  IF nMode <=2 AND LEN(myAnswer) THEN 
                     IF (LEN(myAnswer) = len(str$(answer))-1) AND (VAL(myAnswer) = answer) THEN 'correct ans
                        wrongAns = 0
                        IF done = 0 THEN INCR correct: INCR probs: done = 1
                        CONTROL SHOW STATE cb.hndl, %IDC_HappyFace, %SW_SHOW
                        CONTROL SET TEXT CB.HNDL, %IDC_StatLine1, "Correct answer - very good..."
                        IF nMode = 2 THEN
                           s = s + "  (" + TRIM$(STR$(correct)) + " correct out of" + STR$(probs) + ")"
                           IF probs THEN CONTROL SET TEXT CB.HNDL, %IDC_StatLine2, s
                        END IF
                     ELSEif (LEN(myAnswer) = len(str$(answer))-1) AND (VAL(myAnswer) <> answer) then 'wrong ans
                        IF LEN(myAnswer) = 0 THEN wrongAns = 0 ELSE wrongAns = 1
                        CONTROL SHOW STATE cb.hndl, %IDC_HappyFace, %SW_HIDE
                        CONTROL SET TEXT CB.HNDL, %IDC_StatLine1, ""
                        CONTROL SHOW STATE cb.hndl, %IDC_Instr1, %SW_hide
                     elseif VAL(myAnswer) <> answer then
                        wrongAns = -1   
                     END IF             
                     CONTROL SHOW STATE CB.HNDL, %IDC_Instr2, %SW_HIDE
                     
                     IF wrongAns = 1 THEN 'show correct answer
                        wrongAns = 0: INCR probs
                        IF nMode = 2 THEN 'drill mode only
                           s = "  (" + TRIM$(STR$(correct)) + " correct out of" + STR$(probs) + ")"
                           CONTROL SET TEXT CB.HNDL, %IDC_StatLine2, s
                        END IF
                        s = $CRLF + "  Correct answer is: " + STR$(answer)
                        myMSGBOX s, %MB_ICONINFORMATION, "*** WRONG ANSWER ***", 1, x0 + 350, y0 + 250, %red
                        CONTROL SHOW STATE cb.hndl, %IDC_Instr1, %SW_show
                        DIALOG SEND CB.HNDL, %WM_COMMAND, %IDC_Next, 0                                                              
                     END IF
                  ELSEIF nMode <= 2 THEN
                     CONTROL SHOW STATE cb.hndl, %IDC_HappyFace, %SW_HIDE                            
                     CONTROL SET TEXT CB.HNDL, %IDC_StatLine1, ""
                  END IF
               END IF
            CASE %IDC_Instr1                                                                                
               DIALOG SEND CB.HNDL, %WM_COMMAND, %IDC_Return, 0
            CASE %IDC_Instr2
               DIALOG SEND CB.HNDL, %WM_COMMAND, %IDC_Space, 0                                     
            CASE %IDC_Next 'Next problem...
               if flashCards and init then
                  init = 0
                  CONTROL SHOW STATE cb.hndl, %IDC_Instr1, %SW_SHOW
                  CONTROL SET TEXT CB.HNDL, %IDC_Instr1, "Enter --> Begin"
                  CONTROL disable cb.hndl, %IDC_myAnswer 
                  exit function                                                                        
               elseIF init THEN 'initialize for first problem 
                  init = 0
                  CONTROL SHOW STATE cb.hndl, %IDC_Instr1, %SW_SHOW
                  CONTROL SET TEXT CB.HNDL, %IDC_Instr1, "Enter --> Begin"
                  probNo = 0: probs = 0: correct = 0
                  CONTROL SEND CB.HNDL, %IDC_LearnBtn + nMode - 1, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
                  'CONTROL SEND CB.HNDL, %IDC_LearnBtn, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
                  CONTROL SET FOCUS CB.HNDL, %IDC_myAnswer
                  EXIT FUNCTION
               END IF
               CONTROL SHOW STATE CB.HNDL, %IDC_myAnswer, %SW_SHOW
               IF testTime THEN 'test mode                                   
                  if flashCards then
                     control set text cb.hndl, %IDC_Instr1, "Stop"
                     KillTimer CB.HNDL, %IDC_Timer
                     SetTimer CB.HNDL, %IDC_Timer, 1000*testTime, ByVal %NULL
                     startTime = TIMER 'seconds past midnight
                     
                     INCR probNo: done = 0
                     s = cards(probNo)
                     number1 = VAL(PARSE$(s, 1))
                     number2 = VAL(PARSE$(s, 2))
                     mathOp = VAL(PARSE$(s, 3))
                     op = CHOOSE$(mathOp, " + ", " - ", " x ", " / ")
                     CONTROL SET TEXT CB.HNDL, %IDC_Number1, TRIM$(STR$(number1))
                     CONTROL SET TEXT CB.HNDL, %IDC_Op, op
                     CONTROL SET TEXT CB.HNDL, %IDC_Number2, TRIM$(STR$(number2))
                     CONTROL SET TEXT CB.HNDL, %IDC_Eq, " = "
                     exit function
                     
                  elseIF probNo = 0 THEN 'setup progress bar for time, and initialize new test 
                     maxTime = testTime * 60: timeUp = 0
                     CONTROL SET TEXT CB.HNDL, %IDC_Instr1, "Enter --> Next"
                     CONTROL SET TEXT CB.HNDL, %IDC_StatLine1, "Time:"
                     CONTROL ADD PROGRESSBAR, cb.hndl, %IDC_TimeLeft, "", 60, 345, 300, 20, nStyle
                     PROGRESSBAR SET RANGE CB.HNDL, %IDC_TimeLeft, 0, maxTime 
                     SetTimer CB.HNDL, 0, 1000, BYVAL 0
                     startTime = TIMER 'seconds past midnight
                     REDIM mistakes(0): REDIM correctAns(0)
                  END IF
                  CONTROL GET TEXT CB.HNDL, %IDC_myAnswer TO myAnswer
                  IF LEN(op) THEN 'evaluate myAnswer
                     INCR probs
                     IF LEN(myAnswer) AND VAL(myAnswer) = answer THEN 'correct answer
                        INCR correct
                     ELSE 'wrong answer or unanswered
                        n = UBOUND(mistakes): INCR n
                        REDIM PRESERVE mistakes(n)
                        REDIM PRESERVE correctAns(n)
                        s = STR$(number1) + " " + op + STR$(number2) + "  =  " + myAnswer
                        mistakes(n) = s: correctAns(n) = STR$(answer)
                     END IF
                  END IF
                  IF probNo >= numProbs OR timeUp THEN 'test done - now show results and save them
                     beep: KillTimer cb.hndl, 0: testResults          
                     IF numTests < UBOUND(testData) THEN 'save the results
                        INCR numTests: fileChanged = 1
                        testData(numTests).Date    = compressDate(DATE$)
                        testData(numTests).mathOp  = mathOp
                        testData(numTests).time    = testTime
                        testData(numTests).total   = numProbs                 
                        testData(numTests).correct = correct
                     END IF
                     clearWindow: testTime = 0: startTime = 0: mathOp = 0: op = "": nMode = 0
                     CONTROL SEND CB.HNDL, %IDC_ReptBtn, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
                     CONTROL SET FOCUS CB.HNDL, %IDC_ReptBtn
                     EXIT FUNCTION
                  END IF 
               ELSE 'learn and drill modes 
                  IF wrongAns THEN 'show correct answer                                 
                     wrongAns = 0: INCR probs
                     IF nMode = 2 THEN 'drill mode only
                        s = "  (" + TRIM$(STR$(correct)) + " correct out of" + STR$(probs) + ")"
                        CONTROL SET TEXT CB.HNDL, %IDC_StatLine2, s
                     END IF                                                              
                     s = $CRLF + "  Correct answer is: " + STR$(answer)
                     myMSGBOX s, %MB_ICONINFORMATION, "*** WRONG ANSWER ***", 1, x0 + 350, y0 + 250, %red
                  END IF
               END IF
               FillRect hdc, rc, hBrush
               IF nMode < 3 THEN 'show current mode and status
                  IF nMode = 1 THEN s = "Learning for number" + STR$(numLearn) + "  (" + arith(mathOp) + ")"
                  IF nMode = 2 THEN s = "Drill Mode - " + arith(mathOp)
               ELSEIF nMode = 3 THEN                                                        
                  s = "Test Mode - " + arith(mathOp)
                  s = s + "  (" + TRIM$(STR$(correct)) + " correct out of" + STR$(probs) + ")"
                  CONTROL SET TEXT CB.HNDL, %IDC_StatLine2, s
               END IF
               CONTROL SET TEXT CB.HNDL, %IDC_StatLine2, s
               if probNo = nCards then
                  probNo = 0: if nMode > 1 then randomize: shuffleDeck
               end if
               INCR probNo: done = 0
               s = cards(probNo)
               number1 = VAL(PARSE$(s, 1))
               number2 = VAL(PARSE$(s, 2))
               mathOp = VAL(PARSE$(s, 3))
               op = CHOOSE$(mathOp, " + ", " - ", " x ", " / ")
               CONTROL SET TEXT CB.HNDL, %IDC_Number1, TRIM$(STR$(number1))
               CONTROL SET TEXT CB.HNDL, %IDC_Op, op
               CONTROL SET TEXT CB.HNDL, %IDC_Number2, TRIM$(STR$(number2))
               CONTROL SET TEXT CB.HNDL, %IDC_Eq, " = "
               CONTROL SET TEXT CB.HNDL, %IDC_Answer, ""
               CONTROL SET TEXT CB.HNDL, %IDC_Instr1, "Enter --> Next"
               CONTROL SET TEXT CB.HNDL, %IDC_myAnswer, ""
               CONTROL SET FOCUS CB.HNDL, %IDC_myAnswer
               IF nMode = 1 OR nMode = 2 THEN
                  IF showAllAnswers THEN
                     DIALOG SEND CB.HNDL, %WM_COMMAND, %IDC_Ans, 0
                  ELSE
                     CONTROL SHOW STATE cb.hndl, %IDC_Instr2, %SW_SHOW
                     CONTROL SET TEXT CB.HNDL, %IDC_Instr2, "Space --> Answer"
                     CONTROL SHOW STATE cb.hndl, %IDC_AnsAll, %SW_SHOW
                  END IF
               END IF 
            CASE %IDC_Ans 'Answer please...
               IF nMode = 1 OR nMode = 2 THEN 'Spacebar for learn and drill mode
                  IF mathOp = 1 THEN answer = number1 + number2
                  IF mathOp = 2 THEN answer = number1 - number2
                  IF mathOp = 3 THEN answer = number1 * number2
                  IF mathOp = 4 THEN answer = number1 / number2
                  CONTROL SHOW STATE CB.HNDL, %IDC_myAnswer, %SW_HIDE
                  CONTROL SET TEXT CB.HNDL, %IDC_Answer, TRIM$(STR$(answer))
                  CONTROL SET FOCUS CB.HNDL, %IDC_Answer
                  CONTROL SHOW STATE CB.HNDL, %IDC_HappyFace, %SW_HIDE
                  CONTROL SHOW STATE CB.HNDL, %IDC_Instr2, %SW_HIDE
                  CONTROL SET TEXT CB.HNDL, %IDC_StatLine1, ""
                  FillRect hdc, rc, hBrush
               END IF
         END SELECT
      CASE %WM_TIMER 'one second has passed
         IF startTime THEN
            if flashCards then
               DIALOG SEND cb.hndl, %WM_COMMAND, %IDC_Next, 0
            end if
            n = TIMER - startTime 'seconds
            PROGRESSBAR SET POS cb.hndl, %IDC_TimeLeft, n
            IF n >= maxTime THEN
               IF nMode = 3 THEN
                  timeUp = 1: DIALOG SEND cb.hndl, %WM_COMMAND, %IDC_Next, 0
               END IF
               KillTimer CB.HNDL, 0
            END IF
         END IF
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN
            if iniFileChanged then
               hFile = FREEFILE
               OPEN iniFile FOR output AS hFile
                  print# hFile, saveID
               close #hFile 
            end if
            ZfileChanged = 0
            if maxNum1 <> ZmaxNum1 or maxNum2 <> ZmaxNum2 then ZfileChanged = 1
            if probsPerMin1 <> ZprobsPerMin1 or probsPerMin2 <> ZprobsPerMin1 then ZfileChanged = 1
            IF ZfileChanged THEN 
               saveData 'save if maximums or problemsPerMins have changed in Config
            elseIF fileChanged THEN 'prompt to save the test data
               s = "Data has changed... Save it before quiting?"
               n = MSGBOX(s, %MB_YESNOCANCEL + %MB_ICONQUESTION, "Quit Program")
               IF n = %IDCANCEL THEN FUNCTION = 1: EXIT FUNCTION
               IF n = %IDYES THEN saveData                             
            END IF
         END IF
      CASE %WM_DESTROY                                                                             
   END SELECT
END FUNCTION

SUB greeting()
   LOCAL hGreet, wi, ht AS LONG
   LOCAL ti, s AS STRING
   wi = 300: ht = 370                     
   ti = "MathForKids - Ver " + $verNo
   DIALOG NEW PIXELS, hMain, ti, , , wi, ht, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hGreet
   CONTROL ADD LABEL, hGreet, -1, "Greetings - Glad you're here", 10, 15, 200, 20
   CONTROL ADD LABEL, hGreet, -1, "Please give me your name...", 20, 35, 200, 20
   CONTROL ADD LISTBOX, hGreet, %IDC_ListNames, nameList(), 20, 60, 250, 80
   CONTROL ADD LABEL, hGreet, -1, "I am a new kid here, and my name is:", 20, 155, 250, 20
   CONTROL ADD TEXTBOX, hGreet, %IDC_Name, "", 50, 180, 230, 25
   CONTROL ADD LINE, hGreet, -1, "", 10, 230, 280, 1
   s = "Click Ok and then one of the three mode buttons in the top toolbar... [Learn-Drill-Test]"
   CONTROL ADD LABEL, hGreet, -1, s, 20, 250, 260, 60
   CONTROL ADD BUTTON, hGreet, %IDC_GreetHelp, "&Help", 20, ht - 50, 70, 30
   CONTROL ADD BUTTON, hGreet, %IDOK, "&Ok", wi - 150, ht - 50, 70, 30
   CONTROL ADD BUTTON, hGreet, %IDCANCEL, "&Cancel", wi - 80, ht - 50, 70, 30
   DIALOG SHOW MODAL hGreet CALL greetProc
END SUB
                                                                               
CALLBACK FUNCTION greetProc()
   LOCAL i, n, hAccel AS LONG
   LOCAL s AS STRING
   STATIC helpMode AS LONG
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG         
         if numNames then
            LISTBOX SELECT CB.HNDL, %IDC_ListNames, 1
         else
            CONTROL SET FOCUS CB.HNDL, %IDC_Name
         end if
   
         DIM ac(1 TO 1) AS ACCELAPI
         assignAccl ac(1), %VK_F1, %IDC_GreetHelp
         ACCEL ATTACH CB.HNDL, ac() TO hAccel
         CONTROL SEND CB.HNDL, %IDOK, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
         DIALOG POST CB.HNDL, %WM_USER + 100, 0, 0  'for GUI initializations
      CASE %WM_USER + 100  'GUI initializations
      CASE %WM_COMMAND
         IF CB.CTL = %IDC_ListNames AND CB.CTLMSG = %LBN_DBLCLK THEN
            DIALOG SEND CB.HNDL, %WM_COMMAND, %IDOK, 0
         ELSEIF CB.CTL = %IDOK THEN
            CONTROL GET TEXT CB.HNDL, %IDC_Name TO s                
            IF LEN(s) THEN
               myName = s
            ELSE
               LISTBOX GET TEXT CB.HNDL, %IDC_ListNames TO myName
            END IF
            IF LEN(myName) THEN
               n = INSTR(myName, "."): IF n THEN myName = LEFT$(myName, n - 1)
               DIALOG SET TEXT hMain, "Math for Kids (ver " + $verNo + ") - " + myName
               DIALOG END CB.HNDL
            else
               control set focus cb.hndl, %IDC_Name
               exit function                                                 
            END IF
            dataFile = dataFolder +"\" + myName + ".mfk"
            getData
            if probsPerMin1 = 0 then probsPerMin1 = 12
            if probsPerMin2 = 0 then probsPerMin2 = 12
            if maxNum1 = 0 then maxNum1 = 12
            if maxNum2 = 0 then maxNum2 = 12                        
         ELSEIF CB.CTL = %IDCANCEL THEN
            DIALOG END CB.HNDL
            DIALOG END hMain
         ELSEIF CB.CTL = %IDC_GreetHelp THEN
            CONTROL SET FOCUS CB.HNDL, %IDOK
            appHelp helpFile
         END IF
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN helpMode = 1: DIALOG END hMain
   END SELECT
END FUNCTION

sub buildDeck(kOp AS LONG)          
   'build an unshuffled card deck
   'kOp  = operation number 1 to 7 (add, sub, mul, div, mixAll, mixAddSub, mixMulDiv)
   'allow both (i op j) and (j op i)
   'cards(i) = s1, s2, sOp (i.e. "9, 8, 3" for 9 x 8)
   '-----------------------------------------------------------------------
   LOCAL i, j, j0, j1, k0, k1, n, nn, nDim AS LONG
   local nOp() as long
   if kOp = 1 or kOp = 2 or kOp = 6 then k0 = minNum1: k1 = maxNum1
   if kOp = 3 or kOp = 4 or kOp = 7 then k0 = minNum2: k1 = maxNum2
   if kOp = 5 then k0 = minNum: k1 = maxNum
   nDim = (k1 - k0 + 1) ^ 2 
   if kOp = 5 then nDim = 4 * nDim
   if kOp > 5 then nDim = 2 * nDim
   redim cards(nDim)
    
   if kOp <= 4 then nn = 1: redim nOp(1 to 1): array assign nOp() = kOp
   if kOp = 5 then nn = 4: redim nOp(1 to 4): array assign nOp() = 1, 2, 3, 4                                              
   if kOp = 6 then nn = 2: redim nOp(1 to 2): array assign nOp() = 1, 2
   if kOp = 7 then nn = 2: redim nOp(1 to 2): array assign nOp() = 3, 4
   nCards = 0
   for n = 1 to nn
      j0 = k0: j1 = k1
      IF nMode = 1 THEN j0 = numLearn: j1 = j0                                          
      FOR i = j0 TO j1
         for j = k0 to k1
            if nOp(n) = 4 and j = 0 then iterate 'cannot divide by 0
            if nOp(n) = 4 and (i mod j) then iterate 'no fractions or remainders
            if nOp(n) = 2 and i < j then iterate 'no negatives
            INCR nCards: cards(nCards) = str$(i) + "," + str$(j) + "," + STR$(nOp(n))
         NEXT j
      NEXT i                                  
   next n
   IF nMode > 1 and nMode <= 4 THEN 'not the learning mode... shuffle the deck
      IF nMode = 4 THEN RANDOMIZE testID else randomize 'printed tests use testID as seed 
      shuffleDeck
   END IF                                                                                   
'   debug "file"
'   for i = 1 to nCards                                                              
'      debug i, cards(i)
'   next i                                                                            
end sub 
                                                                
SUB shuffleDeck()                                                     
   LOCAL i, j AS LONG
   WHILE j < nCards
      INCR j: i = RND(j, nCards)               'select the next random card index
      IF i <> j THEN SWAP cards(i), cards(j)   'and move it to next
   WEND                                                                                           
END SUB

SUB learn()
   LOCAL hLearn, nStyle, wi, ht AS LONG
   LOCAL ti AS STRING
   ti = "Learn Math Tables": wi = 300: ht = 240
   DIALOG NEW PIXELS, hMain, ti, , , wi, ht, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hLearn
   CONTROL ADD LABEL, hLearn, -1, "Learn for this number:", 20, 10, 130, 20
   nStyle = %CBS_DROPDOWNLIST OR %WS_TABSTOP OR %WS_VSCROLL OR %CBS_NOINTEGRALHEIGHT
   CONTROL ADD COMBOBOX, hLearn, %IDC_NumLearn, , 150, 10, 60, 250, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hLearn, -1, "Choose a math function:", 20, 50, 200, 20
   CONTROL ADD OPTION, hLearn, %IDC_TestAdd, "Add", 50, 75, 80, 15, %WS_GROUP
   CONTROL ADD OPTION, hLearn, %IDC_TestSub, "Sub", 50, 95, 80, 15
   CONTROL ADD OPTION, hLearn, %IDC_TestMul, "Mult", 50, 115, 80, 15
   CONTROL ADD OPTION, hLearn, %IDC_TestDiv, "Div", 50, 135, 80, 15
   CONTROL ADD CHECKBOX, hLearn, %IDC_AnsAll, "Show all answers", 20, 160, 190, 20
   CONTROL ADD BUTTON, hLearn, %IDOK, "&Ok", wi - 140, ht - 40, 60, 30
   CONTROL ADD BUTTON, hLearn, %IDCANCEL, "&Cancel", wi - 70, ht - 40, 60, 30
   DIALOG SHOW MODAL hLearn CALL learnProc
END SUB

CALLBACK FUNCTION learnProc()
   LOCAL i, k, n AS LONG
   LOCAL s AS STRING
   STATIC kVal AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG 
         n = MAX(lastOp, 1)
         IF n < 3 THEN minNum = minNum1: maxNum = maxNum1 ELSE minNum = minNum2: maxNum = maxNum2
         CONTROL SET OPTION CB.HNDL, %IDC_TestAdd + n - 1, %IDC_TestAdd, %IDC_TestDiv
         FOR i = minNum TO maxNum
            COMBOBOX ADD CB.HNDL, %IDC_NumLearn, STR$(i)
         NEXT i
         kVal = lastNumLearned
         COMBOBOX SELECT CB.HNDL, %IDC_NumLearn, lastNumLearned - minNum + 1
         CONTROL SET CHECK CB.HNDL, %IDC_AnsAll, showAllAnswers
         CONTROL SET FOCUS CB.HNDL, %IDC_NumLearn
         CONTROL SEND CB.HNDL, %IDOK, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
      CASE %WM_COMMAND
         IF CB.CTL = %IDC_NumLearn AND CB.CTLMSG = %CBN_SELENDOK THEN
            COMBOBOX GET SELECT CB.HNDL, %IDC_NumLearn TO kVal
         ELSEIF CB.CTL = %IDOK THEN
            FOR i = %IDC_TestAdd TO %IDC_TestDiv
               CONTROL GET CHECK CB.HNDL, i TO n
               IF n THEN mathOp = i - %IDC_TestAdd + 1: EXIT FOR         
            NEXT i
            CONTROL GET TEXT CB.HNDL, %IDC_NumLearn TO s
            numLearn = VAL(s): init = 1
            init = 1: buildDeck mathOp
            IF numLearn <> lastNumLearned THEN fileChanged = -1
            IF mathOp <> lastOp THEN fileChanged = -1
            lastOp = mathOp: lastNumLearned = numLearn
            CONTROL GET CHECK CB.HNDL, %IDC_AnsAll TO n
            IF n THEN showAllAnswers = 1 ELSE showAllAnswers = 0
            DIALOG END CB.HNDL
            DIALOG SEND hMain, %WM_COMMAND, %IDC_Next, 0
         ELSEIF CB.CTL = %IDCANCEL THEN
            nMode = 0: DIALOG END CB.HNDL
         END IF
   END SELECT
END FUNCTION

SUB drill()
   LOCAL hDrill, wi, ht, nStyle AS LONG
   LOCAL ti AS STRING                                                                                            
   ti = "Drill Math Tables": wi = 360: ht = 220
   DIALOG NEW PIXELS, hMain, ti, , , wi, ht, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hDrill
   CONTROL ADD LABEL, hDrill, -1, "Choose a math function:", 20, 10, 200, 30
   CONTROL ADD OPTION, hDrill, %IDC_TestAdd, "Add", 50, 40, 80, 15, %WS_GROUP
   CONTROL ADD OPTION, hDrill, %IDC_TestSub, "Sub", 50, 60, 80, 15
   CONTROL ADD OPTION, hDrill, %IDC_TestMul, "Mult", 50, 80, 80, 15
   CONTROL ADD OPTION, hDrill, %IDC_TestDiv, "Div", 50, 100, 80, 15
   CONTROL ADD OPTION, hDrill, %IDC_MixAll, "Mix All", 150, 40, 120, 15
   CONTROL ADD OPTION, hDrill, %IDC_AddSub, "Mix Add+Sub", 150, 60, 120, 15
   CONTROL ADD OPTION, hDrill, %IDC_MulDiv, "Mix Mult+Div", 150, 80, 120, 15
   control add checkbox, hDrill, %IDC_FlashCards, "Flash cards - Timer(secs):", 20, 130, 180, 15
   nStyle = %CBS_DROPDOWNLIST OR %WS_TABSTOP
   CONTROL ADD COMBOBOX, hDrill, %IDC_Timer, timeList(), 200, 128, 45, 180, nStyle
   CONTROL ADD BUTTON, hDrill, %IDOK, "&Ok", 170, 175, 60, 30
   CONTROL ADD BUTTON, hDrill, %IDCANCEL, "&Cancel", 240, 175, 60, 30
   DIALOG SHOW MODAL hDrill CALL drillProc
END SUB

CALLBACK FUNCTION drillProc()
   LOCAL i, n AS LONG
   local s as string
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         combobox select cb.hndl, %IDC_Timer, 2
         CONTROL SET OPTION CB.HNDL, %IDC_TestAdd, %IDC_TestAdd, %IDC_MulDiv
         CONTROL SEND CB.HNDL, %IDOK, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
      CASE %WM_COMMAND
         if cb.ctl = %IDC_FlashCards then
            control get check cb.hndl, cb.ctl to flashCards   
         elseIF CB.CTL = %IDOK THEN
            FOR i = %IDC_TestAdd TO %IDC_MulDiv
               CONTROL GET CHECK CB.HNDL, i TO n
               IF n THEN mathOp = i - %IDC_TestAdd + 1: EXIT FOR             
            NEXT i       
            init = 1: buildDeck mathOp
            if flashCards then
               combobox get select cb.hndl, %IDC_Timer to n
               testTime = val(timeList(n))
            end if
            DIALOG END CB.HNDL 
            DIALOG SEND hMain, %WM_COMMAND, %IDC_Next, 0
         ELSEIF CB.CTL = %IDCANCEL THEN
            nMode = 0: DIALOG END CB.HNDL
         END IF
   END SELECT
END FUNCTION
                                                                                                                        
SUB testJob()
   LOCAL hTestJob AS LONG
   LOCAL ti AS STRING 
   ti = "Test Options"
   DIALOG NEW PIXELS, hMain, ti, , , 280, 160, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hTestJob
   CONTROL ADD BUTTON, hTestJob, %IDC_CompuTest, "Take test on computer", 20, 20, 150, 25  ', %WS_GROUP
   CONTROL ADD BUTTON, hTestJob, %IDC_PrintTest, "Print test pages", 20, 60, 150, 25
   CONTROL ADD BUTTON, hTestJob, %IDC_ReptScore, "Report printed test", 20, 100, 150, 25
   DIALOG SHOW MODAL hTestJob CALL testJobProc
END SUB

CALLBACK FUNCTION testJobProc()
   'nMode = 3  taking the test on the computer
   '      = 4  printing test pages seeded by test number (1, 2, 3,... A, B, C, ...)
   '      = 5  saving test scores for reporting
   '------------------------------------------------------------------------------------------
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
      CASE %WM_COMMAND
         IF CB.CTL = %IDC_CompuTest THEN
            DIALOG END CB.HNDL
            nMode = 3: takeTest
         ELSEIF CB.CTL = %IDC_PrintTest THEN
            DIALOG END CB.HNDL
            nMode = 4: printTestPages
         ELSEIF CB.CTL = %IDC_ReptScore THEN
            DIALOG END CB.HNDL
            reportScore
         END IF
   END SELECT
END FUNCTION

SUB takeTest()
   LOCAL hTest, nStyle, wi, ht AS LONG
   LOCAL ti, s AS STRING
   ti = "Math Test": wi = 300: ht = 300
   DIALOG NEW PIXELS, hMain, ti, , , 300, 300, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hTest
   CONTROL ADD LABEL, hTest, -1, "Amount of time (mins):", 25, 10, 140, 15
   nStyle = %CBS_DROPDOWNLIST OR %WS_TABSTOP
   CONTROL ADD COMBOBOX, hTest, %IDC_TestTime, timeList(), 160, 9, 45, 180, nStyle
   IF nMode < 3 THEN CONTROL ADD LABEL, hTest, -1, "... Just to practice", 120, 35, 150, 15
   CONTROL ADD LABEL, hTest, %IDC_Problems, "", 25, 70, 160, 15      '130
   CONTROL ADD LABEL, hTest, -1, "Choose one to test:", 25, 110, 120, 15
   CONTROL ADD OPTION, hTest, %IDC_TestAdd, "Add", 50, 140, 80, 15, %WS_GROUP
   CONTROL ADD OPTION, hTest, %IDC_TestSub, "Sub", 50, 160, 80, 15
   CONTROL ADD OPTION, hTest, %IDC_TestMul, "Mult", 50, 180, 80, 15
   CONTROL ADD OPTION, hTest, %IDC_TestDiv, "Div", 50, 200, 80, 15
   CONTROL ADD OPTION, hTest, %IDC_MixAll, "Mix All", 150, 140, 120, 15
   CONTROL ADD OPTION, hTest, %IDC_AddSub, "Mix Add+Sub", 150, 160, 120, 15
   CONTROL ADD OPTION, hTest, %IDC_MulDiv, "Mix Mul+Div", 150, 180, 120, 15
   CONTROL ADD BUTTON, hTest, %IDOK, "&Ok", wi - 150, ht - 50, 60, 30
   CONTROL ADD BUTTON, hTest, %IDCANCEL, "&Cancel", wi - 80, ht - 50, 60, 30
   DIALOG SHOW MODAL hTest CALL takeTestProc
END SUB                          

CALLBACK FUNCTION takeTestProc()
   LOCAL i, n AS LONG
   static k as long
   LOCAL s AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         COMBOBOX SELECT CB.HNDL, %IDC_TestTime, 10
         k = 10 * probsPerMin1
         s = "Number of problems =" + str$(k)
         CONTROL set text cb.hndl, %IDC_Problems, s
         CONTROL SET OPTION CB.HNDL, %IDC_TestAdd, %IDC_TestAdd, %IDC_MixAll         
         CONTROL SEND CB.HNDL, %IDOK, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
      CASE %WM_COMMAND                                                                  
         IF CB.CTL = %IDC_TestTime AND CB.CTLMSG = %CBN_SELCHANGE THEN
            COMBOBOX GET TEXT CB.HNDL, CB.CTL TO s: n = VAL(s)
            IF mathOp <= 2 OR mathOp = 6 THEN
               k = probsPerMin1 * n
            ELSEIF mathOp <= 4 OR mathOp = 7 THEN
               k = probsPerMin2 * n
            ELSE 'mathOp = 5
               k = (probsPerMin1 + probsPerMin2)/2 * n
            END IF
            s = "Number of problems =" + str$(k)
            CONTROL set text cb.hndl, %IDC_Problems, s
         ELSEIF CB.CTL >= %IDC_TestAdd AND CB.CTL <= %IDC_MulDiv THEN
            mathOp = CB.CTL - %IDC_TestAdd + 1
            COMBOBOX GET TEXT CB.HNDL, %IDC_TestTime TO s: n = VAL(s)
            IF CB.CTL <= %IDC_TestSub OR CB.CTL = %IDC_AddSub THEN
               k = probsPerMin1 * n
            ELSEIF CB.CTL <= %IDC_TestDiv OR CB.CTL = %IDC_MulDiv THEN
               k = probsPerMin2 * n
            ELSE
               k = (probsPerMin1 + probsPerMin2)/2 * n
            END IF
            s = "Number of problems =" + str$(k)
            CONTROL set text cb.hndl, %IDC_Problems, s
         ELSEIF CB.CTL = %IDOK THEN
            COMBOBOX GET TEXT CB.HNDL, %IDC_TestTime TO s: testTime = VAL(s)
            'CONTROL GET TEXT CB.HNDL, %IDC_TestProbs TO s: numProbs = VAL(s)
            numProbs = k
            FOR i = %IDC_TestAdd TO %IDC_MixAll
               CONTROL GET CHECK CB.HNDL, i TO n
               IF n THEN mathOp = i - %IDC_TestAdd + 1: EXIT FOR
            NEXT i
            buildDeck mathOp
            init = 1
            DIALOG END CB.HNDL
            DIALOG SEND hMain, %WM_COMMAND, %IDC_Next, 0
         ELSEIF CB.CTL = %IDCANCEL THEN
            nMode = 0: DIALOG END CB.HNDL
         END IF
   END SELECT
END FUNCTION
                  
SUB printTestPages()
   LOCAL hPrnTest, nStyle AS LONG
   LOCAL ti AS STRING
   ti = "Print Test Pages"
   DIALOG NEW PIXELS, hMain, ti, , , 300, 220, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hPrnTest
   CONTROL ADD TEXTBOX, hPrnTest, %IDC_TestID, "", 20, 20, 40, 20
   CONTROL ADD LABEL, hPrnTest, -1, "Test ID", 65, 20, 120, 15
   CONTROL ADD TEXTBOX, hPrnTest, %IDC_NumCopies, "", 20, 50, 40, 20
   CONTROL ADD LABEL, hPrnTest, -1, "Number of copies", 65, 50, 120, 15
   nStyle = %CBS_DROPDOWN OR %WS_TABSTOP
   CONTROL ADD COMBOBOX, hPrnTest, %IDC_ProbTypes, , 20, 80, 75, 180, nStyle
   CONTROL ADD LABEL, hPrnTest, -1, "Problem types", 105, 80, 120, 15
   CONTROL ADD CHECKBOX, hPrnTest, %IDC_InclAns, "Answers to last page printed", 20, 120, 190, 15
   CONTROL ADD BUTTON, hPrnTest, %IDOK, "&Ok", 120, 170, 60, 30
   CONTROL ADD BUTTON, hPrnTest, %IDCANCEL, "&Cancel", 185, 170, 60, 30
   DIALOG SHOW MODAL hPrnTest CALL prnTestPagesProc
END SUB

CALLBACK FUNCTION prnTestPagesProc()
   LOCAL n, nCopies, prnAns AS LONG
   LOCAL s AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Add"
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Sub"
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Mul"
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Div"
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Mixed"
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Add/Sub"
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Mul/Div"
         COMBOBOX SELECT CB.HNDL, %IDC_ProbTypes, 1
         n = saveID + 1
         control set text cb.hndl, %IDC_TestID, str$(n)
      CASE %WM_COMMAND
         IF CB.CTL = %IDOK THEN
            COMBOBOX GET SELECT CB.HNDL, %IDC_ProbTypes TO mathOp 
            CONTROL GET TEXT CB.HNDL, %IDC_TestID TO s: testID = val(s)
            if testID > saveID then saveID = testID: iniFileChanged = 1                                          
            CONTROL GET TEXT CB.HNDL, %IDC_NumCopies TO s: nCopies = VAL(s)
            CONTROL GET CHECK CB.HNDL, %IDC_InclAns TO prnAns
            printPages(testID, nCopies, prnAns)
            nMode = 0: DIALOG END CB.HNDL
         ELSEIF CB.CTL = %IDCANCEL THEN
            nMode = 0: DIALOG END CB.HNDL
         ELSEIF CB.CTL = %IDC_InclAns THEN
            CONTROL GET CHECK CB.HNDL, %IDC_InclAns TO prnAns
            'IF prnAns THEN CONTROL SET TEXT CB.HNDL, %IDC_NumCopies, "1"
         END IF
   END SELECT
END FUNCTION
                                                                         
SUB printPages(testID AS long, numCopies AS LONG, prnAns AS LONG)
   LOCAL i, j, n, n1, n2, nMax, probNo, nCopy AS LONG
   LOCAL x, y, cx, cy, xSpac, ySpac, xx AS DOUBLE
   LOCAL s, s1, s2, op, printerName AS STRING
   LOCAL oTPrint AS iTPrint
   LET oTPrint = CLASS "cTPrint"
   numCopies = MAX(numCopies, 1)                                               
   oTPrint.setCopies(numCopies)
   printerName = oTPrint.choosePrinter
   IF LEN(printerName) = 0 THEN EXIT SUB
   xSpac = 1.00: ySpac = .90
   oTPrint.newFont("Courier New", 12)
   oTPrint.getCharSize(cx, cy)
   oTPrint.beginDoc("Math Test")
   probNo = 0
   buildDeck mathOp
   oTPrint.beginPage
   IF LEN(testID) THEN s = "Test No." + str$(testID) + " - " + arith(mathOp)
   x = oTPrint.getTextWidth(s)
   oTPrint.printText(s, (8.5 - x)/2, 0.75)
   y = 1.5
   FOR i = 1 TO 10
      x = 1.20
      FOR j = 1 TO 7
         INCR probNo: s = cards(probNo)
         s1 = PARSE$(s, 1): s2 = PARSE$(s, 2): mathOp = VAL(PARSE$(s, 3))
         n1 = VAL(s1): n2 = VAL(s2)
         IF mathOp = 4 THEN 'division                                                   
            n = MAX(LEN(s1), LEN(s2)): s = STRING$(n, "_")
            xx = x - (n-1)*cx
            oTPrint.printText(s, xx, y + 0.10*cy)
            oTPrint.printText(s1, x - (LEN(s1)-1)*cx, y)
            xx = (LEN(s1)+LEN(s2))/2 - 1  'to center denominator
            oTPrint.printText(s2, x - xx*cx, y + 1.10*cy)                      
            s = "=": IF prnAns THEN s = s + TRIM$(STR$(n1/n2))
            oTPrint.printText(s, x + 1.25*cx, y + 0.60*cy)                     
         ELSE
            op = CHOOSE$(mathOp, "+ ", "- ", "x ")
            oTPrint.printText(s1, x - (LEN(s1)-1)*cx, y)
            xx = x - (LEN(s2)+1)*cx
            s = STRING$(LEN(s2)+2, "_")                                          
            oTPrint.printText(s, xx, y + 1.10 * cy)
            oTPrint.printText(op + s2, xx, y + cy)
            IF prnAns THEN
               s = TRIM$(STR$(CHOOSE&(mathOp, n1+n2, n1-n2, n1*n2)))
               oTPrint.printText(s, x - (LEN(s)-1)*cx, y + 2.1*cy)
            END IF
         END IF
         x = x + xSpac
         IF probNo = nCards THEN 
            probNo = 0: randomize testID: shuffleDeck
         end if
      NEXT j
      y = y + ySpac
   NEXT i 
   oTPrint.closePage
   oTPrint.closeDoc
END SUB                                                                                               

SUB reportScore()
   LOCAL hReptScore, nStyle AS LONG
   LOCAL ti AS STRING
   ti = "Save Test Score"
   DIALOG NEW PIXELS, hMain, ti, , , 300, 220, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hReptScore
   CONTROL ADD TEXTBOX, hReptScore, %IDC_TestDate, "", 20, 20, 75, 20
   nStyle = %CBS_DROPDOWN OR %WS_TABSTOP
   CONTROL ADD COMBOBOX, hReptScore, %IDC_ProbTypes, , 20, 60, 75, 180, nStyle
   CONTROL ADD TEXTBOX, hReptScore, %IDC_Correct, "", 20, 100, 50, 20
   CONTROL ADD TEXTBOX, hReptScore, %IDC_TestProbs, "", 165, 100, 50, 20
   CONTROL ADD LABEL, hReptScore, -1, "Test date", 105, 20, 120, 15
   CONTROL ADD LABEL, hReptScore, -1, "Problem types", 105, 60, 120, 15
   CONTROL ADD LABEL, hReptScore, -1, "Correct out of:", 75, 100, 90, 15
   CONTROL ADD BUTTON, hReptScore, %IDOK, "&Ok", 120, 150, 60, 30
   CONTROL ADD BUTTON, hReptScore, %IDCANCEL, "&Cancel", 185, 150, 60, 30
   DIALOG SHOW MODAL hReptScore CALL reportScoreProc
END SUB

CALLBACK FUNCTION reportScoreProc()
   LOCAL n AS LONG, s AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Add"                  
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Sub"
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Mul"
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Div"
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Mixed"
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Add/Sub"
         COMBOBOX ADD CB.HNDL, %IDC_ProbTypes, "Mul/Div"
         CONTROL SET TEXT CB.HNDL, %IDC_TestDate, DATE$
         CONTROL SET TEXT CB.HNDL, %IDC_TestProbs, "70"
      CASE %WM_COMMAND
         IF CB.CTL = %IDOK THEN
            INCR numTests: fileChanged = 1
            CONTROL GET TEXT CB.HNDL, %IDC_TestDate TO s
            testData(numTests).Date = compressDate(s)
            COMBOBOX GET SELECT CB.HNDL, %IDC_ProbTypes TO n
            testData(numTests).mathOp = n
            CONTROL GET TEXT CB.HNDL, %IDC_Correct TO s 
            testData(numTests).correct = VAL(s)
            CONTROL GET TEXT CB.HNDL, %IDC_TestProbs TO s
            testData(numTests).total = VAL(s)
            nMode = 0: DIALOG END CB.HNDL
         ELSEIF CB.CTL = %IDCANCEL THEN
            nMode = 0: DIALOG END CB.HNDL
         END IF
   END SELECT
END FUNCTION

SUB config()
   LOCAL hConfig, nStyle, wi, ht AS LONG
   LOCAL ti AS STRING
   ti = "Configure Program": wi = 400: ht = 300
   DIALOG NEW PIXELS, hMain, ti, , , wi, ht, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hConfig

   CONTROL ADD LABEL, hConfig, -1, "Add and Sub", 10, 10, 200, 20
   CONTROL ADD LABEL, hConfig, -1, "Number of problems per min:", 20, 30, 190, 20
   CONTROL ADD LABEL, hConfig, -1, "Number Range to work with:", 20, 50, 190, 20
   CONTROL ADD TEXTBOX, hConfig, %IDC_numProbs1, STR$(probsPerMin1), 200, 30, 40, 20
   CONTROL ADD TEXTBOX, hConfig, %IDC_minNum1, "1", 190, 50, 30, 20                     
   CONTROL ADD LABEL, hConfig, -1, "thru", 225, 50, 25, 20                                   
   CONTROL ADD TEXTBOX, hConfig, %IDC_maxNum1, STR$(maxNum1), 250, 50, 30, 20
                                                                                           
   CONTROL ADD LABEL, hConfig, -1, "Mult and Div", 10, 90, 200, 20
   CONTROL ADD LABEL, hConfig, -1, "Number of problems per min:", 20, 110, 190, 20
   CONTROL ADD LABEL, hConfig, -1, "Number Range to work with:", 20, 130, 190, 20
   CONTROL ADD TEXTBOX, hConfig, %IDC_numProbs2, STR$(probsPerMin2), 200, 110, 40, 20
   control add TEXTBOX, hConfig, %IDC_minNum2, "1", 190, 130, 30, 20 
   CONTROL ADD LABEL, hConfig, -1, "thru", 225, 130, 20, 20
   CONTROL ADD TEXTBOX, hConfig, %IDC_maxNum2, STR$(maxNum2), 250, 130, 30, 20

   CONTROL ADD LABEL, hConfig, -1, "Data Folder:", 10, 200, 80, 30
   nStyle = %WS_TABSTOP OR %WS_BORDER OR %ES_AUTOHSCROLL OR %ES_READONLY
   CONTROL ADD TEXTBOX, hConfig, %IDC_DataLoc, dataFolder, 90, 200, wi - 100, 25, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hConfig, %IDOK, "&Ok", wi - 140, ht - 40, 60, 30
   CONTROL ADD BUTTON, hConfig, %IDCANCEL, "&Cancel", wi - 70, ht - 40, 60, 30
   DIALOG SHOW MODAL hConfig CALL configProc
END SUB

CALLBACK FUNCTION configProc()
   LOCAL s AS STRING
   SELECT CASE CBMSG
      CASE %WM_COMMAND
         IF CB.CTL = %IDOK THEN
            CONTROL GET TEXT CB.HNDL, %IDC_numProbs1 TO s: probsPerMin1 = VAL(s)
            CONTROL GET TEXT CB.HNDL, %IDC_minNum1 TO s: minNum1 = VAL(s)
            CONTROL GET TEXT CB.HNDL, %IDC_maxNum1 TO s: maxNum1 = VAL(s)
            CONTROL GET TEXT CB.HNDL, %IDC_numProbs2 TO s: probsPerMin2 = VAL(s)
            CONTROL GET TEXT CB.HNDL, %IDC_minNum2 TO s: minNum2 = VAL(s)
            CONTROL GET TEXT CB.HNDL, %IDC_maxNum2 TO s: maxNum2 = VAL(s)
            maxNum = MAX(maxNum1, maxNum2)
            DIALOG END CB.HNDL
         ELSEIF CB.CTL = %IDCANCEL THEN
            DIALOG END CB.HNDL
         END IF
   END SELECT
END FUNCTION

SUB report()
   LOCAL hRept, nStyle, wi, ht AS LONG
   LOCAL ti AS STRING
   ti = "Report Progress": wi = 660: ht = 450 
   DIALOG NEW pixels, hMain, ti, , , wi, ht, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hRept
   nStyle = %WS_TABSTOP OR %WS_VSCROLL OR %LBS_DISABLENOSCROLL OR %LBS_USETABSTOPS
   CONTROL ADD LISTBOX, hRept, %IDC_Report, , 0, 20, wi, ht - 75, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD OPTION, hRept, %IDC_Percent, "Percent correct", 150, ht - 50, 120, 20
   CONTROL ADD OPTION, hRept, %IDC_Ratio, "Correct / Total", 150, ht - 30, 120, 20
   CONTROL ADD BUTTON, hRept, %IDCANCEL, "&Cancel", 400, ht - 45, 75, 30
   DIALOG SHOW MODAL hRept CALL reportProc
END SUB

CALLBACK FUNCTION reportProc()
   LOCAL i AS LONG, v AS DOUBLE
   LOCAL s, s1, s2, s3, s4, s5, s6, s7 AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         prepareReport CB.HNDL
         CONTROL SET OPTION CB.HNDL, %IDC_Percent, %IDC_Percent, %IDC_Ratio
         LISTBOX RESET CB.HNDL, %IDC_Report
         FOR i = 1 TO numTests 'percent is the default display option
            v = CDBL(testData(i).Correct) / CDBL(testData(i).Total) * 100
            s = FORMAT$(v, fmt)
            s1 = "": s2 = "": s3 = "": s4 = "": s5 = "": s6 = "": s7 = ""
            IF testData(i).mathOp = 1 THEN s1 = s
            IF testData(i).mathOp = 2 THEN s2 = s
            IF testData(i).mathOp = 3 THEN s3 = s           
            IF testData(i).mathOp = 4 THEN s4 = s
            IF testData(i).mathOp = 5 THEN s5 = s
            IF testData(i).mathOp = 6 THEN s6 = s
            IF testData(i).mathOp = 7 THEN s7 = s
            s = $TAB + expandDate(testData(i).date) + $TAB + s1 + $TAB + s2 + $TAB + s3 + $TAB + s4 _
                                                    + $TAB + s5 + $TAB + s6 + $TAB + s7
            LISTBOX ADD CB.HNDL, %IDC_Report, s
         NEXT i
         LISTBOX SELECT CB.HNDL, %IDC_Report, 1
         CONTROL SET FOCUS CB.HNDL, %IDC_Report
      CASE %WM_COMMAND
         IF CB.CTL = %IDC_Percent OR CB.CTL = %IDC_Ratio THEN 'display option clicked
            LISTBOX RESET CB.HNDL, %IDC_Report
            FOR i = 1 TO numTests
               IF CB.CTL = %IDC_Percent THEN
                  v = CDBL(testData(i).Correct) / CDBL(testData(i).Total) * 100
                  s = FORMAT$(v, fmt)
               ELSE
                  s = STR$(testData(i).Correct) + " /" + STR$(testData(i).Total)
               END IF
               s1 = "": s2 = "": s3 = "": s4 = "": s5 = "": s6 = "": s7 = ""
               IF testData(i).mathOp = 1 THEN s1 = s
               IF testData(i).mathOp = 2 THEN s2 = s
               IF testData(i).mathOp = 3 THEN s3 = s
               IF testData(i).mathOp = 4 THEN s4 = s
               IF testData(i).mathOp = 5 THEN s5 = s 
               IF testData(i).mathOp = 6 THEN s6 = s
               IF testData(i).mathOp = 7 THEN s7 = s
               s = $TAB + expandDate(testData(i).date) + $TAB + s1 + $TAB + s2 + $TAB + s3 + $TAB + s4 _
                                                       + $TAB + s5 + $TAB + s6 + $TAB + s7
               LISTBOX ADD CB.HNDL, %IDC_Report, s
            NEXT i
            LISTBOX SELECT CB.HNDL, %IDC_Report, 1
            CONTROL SET FOCUS CB.HNDL, %IDC_Report
         ELSEIF CB.CTL = %IDOK OR CB.CTL = %IDCANCEL THEN
            DIALOG END CB.HNDL
            CONTROL SEND hMain, %IDC_LearnBtn, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
         END IF
   END SELECT
END FUNCTION

SUB prepareReport(hRept AS LONG)
   LOCAL lptr AS LONG PTR
   LOCAL x0, x1, x2, x3, x4, x5, x6, x7, x8, y, i AS LONG
   DIM tabstops(7) AS LONG
   x0 = 0
   x1 = 80
   x2 = 160
   x3 = 240
   x4 = 320       
   x5 = 400
   x6 = 480
   x7 = 560
   x8 = 640
   tabstops(0) = x0 + 5
   tabstops(1) = x1 + 20
   tabstops(2) = x2 + 20
   tabstops(3) = x3 + 20
   tabstops(4) = x4 + 20
   tabstops(5) = x5 + 20               
   tabstops(6) = x6 + 20              
   tabstops(7) = x7 + 20
   FOR i = 0 TO 7
      DIALOG PIXELS hRept, tabstops(i), y TO UNITS y, tabstops(i)   '... note this pbwin10 bug work around
   NEXT i
   lptr = VARPTR(tabstops(0))
   CONTROL SEND hRept, %IDC_Report, %LB_SETTABSTOPS, 8, lptr
   y = 0
   CONTROL ADD LABEL, hRept, -1, "Date", x0, y, x1 - x0, 20, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hRept, -1, "Add ", x1, y, x2 - x1, 20, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hRept, -1, "Sub ", x2, y, x3 - x2, 20, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hRept, -1, "Mult", x3, y, x4 - x3, 20, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hRept, -1, "Div ", x4, y, x5 - x4, 20, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hRept, -1, "Mix ", x5, y, x6 - x5, 20, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hRept, -1, "Add/Sub", x6, y, x7 - x6, 20, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hRept, -1, "Mul/Div", x7, y, x8 - x7, 20, %SS_CENTER, %WS_EX_STATICEDGE
END SUB

SUB AssignAccl(tAccel AS ACCELAPI, wKey AS WORD, wCmd AS WORD, OPT BYVAL FVirt AS BYTE)
   IF FVirt = 0 THEN FVirt = %FVIRTKEY
   tAccel.fVirt = FVirt
   tAccel.key   = wKey
   tAccel.cmd   = wCmd
END SUB

SUB clearWindow()
   CONTROL SET TEXT hMain, %IDC_Number1, ""
   CONTROL SET TEXT hMain, %IDC_Op, ""
   CONTROL SET TEXT hMain, %IDC_Number2, ""
   CONTROL SET TEXT hMain, %IDC_Eq, ""
   CONTROL SET TEXT hMain, %IDC_Answer, ""
   CONTROL SET TEXT hMain, %IDC_myAnswer, ""
   CONTROL SET TEXT hMain, %IDC_Instr1, ""
   CONTROL SET TEXT hMain, %IDC_Instr2, ""
   CONTROL SET TEXT hMain, %IDC_StatLine1, ""
   CONTROL SET TEXT hMain, %IDC_StatLine2, ""
   CONTROL SHOW STATE hMain, %IDC_myAnswer, %SW_HIDE
   CONTROL SHOW STATE hMain, %IDC_Instr1, %SW_HIDE
   CONTROL SHOW STATE hMain, %IDC_Instr2, %SW_HIDE
   CONTROL KILL hMain, %IDC_TimeLeft: KillTimer hMain, 0                          
   nMode = 0
END SUB

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

FUNCTION compressDate(s AS STRING) AS WORD
   '4 bit month, 5 bit day, 7 bit year
   LOCAL mo, day, yr AS WORD, year AS STRING
   IF LEN(s) THEN
      mo = VAL(PARSE$(s, ANY "-/", 1))
      day = VAL(PARSE$(s, ANY "-/", 2))
      year = PARSE$(s, ANY "-/", 3)
      yr = VAL(year)
      IF LEN(year) <> 4 THEN yr = 2000 + yr
      yr = yr - 1980
      ROTATE RIGHT yr, 7
      ROTATE LEFT mo, 5
      FUNCTION = yr + mo + day
   END IF
END FUNCTION

FUNCTION expandDate(w AS WORD) AS STRING
   LOCAL mo, day, yr AS WORD
   LOCAL m, d AS STRING
   day = w AND 31
   mo = w AND 480
   yr = w AND 65024
   ROTATE LEFT yr,7
   ROTATE RIGHT mo,5
   m = RIGHT$("0" + LTRIM$(STR$(mo)), 2)
   d = RIGHT$("0" + LTRIM$(STR$(day)), 2)
   FUNCTION = m + "-" + d + "-" + LTRIM$(STR$(yr + 1980))
END FUNCTION

SUB getData()
   LOCAL hFile, i AS LONG
   LOCAL s AS STRING
   hFile = FREEFILE
   OPEN dataFile FOR BINARY AS hFile
   s = SPACE$(11)                              
   GET hFile,, s
   IF s = "MathForKids" THEN
      GET hFile,, maxNum1       'add, sub
      GET hFile,, maxNum2       'mul, div
      GET hFile,, probsPerMin1  'add, sub
      GET hFile,, probsPerMin2  'mul, div
      GET hFile, , lastOp
      GET hFile, , lastNumLearned
      GET hFile,, numTests
      FOR i = 1 TO numTests
         GET hFile,, testData(i)
      NEXT i
   END IF
   ZmaxNum1 = maxNum1: ZmaxNum2 = maxNum2
   ZprobsPerMin1 = probsPerMin1: ZprobsPerMin2 = probsPerMin2
   minNum1 = 1: minNum2 = 1
   minNum = min(minNum1, minNum2)
   maxNum = MAX(maxNum1, maxNum2)
   CLOSE hFile
END SUB

SUB saveData()
   LOCAL hFile, i, m1, m2 AS LONG
   LOCAL progID AS STRING * 11
'   m1 = 100 * minNum1 + maxNum1
'   m2 = 100 * minNum2 + maxNum2
   hFile = FREEFILE
   OPEN dataFile FOR BINARY AS hFile
   progID = "MathForKids"
   PUT hFile, , progID
   PUT hFile, , maxNum1  'm1
   PUT hFile, , maxNum2  'm2
   PUT hFile, , probsPerMin1
   PUT hFile, , probsPerMin2
   PUT hFile, , lastOp
   PUT hFile, , lastNumLearned
   IF fileChanged > 0 THEN                 
      PUT hFile, , numTests
      FOR i = 1 TO numTests
         PUT hFile , , testData(i)
      NEXT i
   END IF
   CLOSE hFile
END SUB

FUNCTION myMsgBox(msg AS STRING, OPT BYVAL nStyle AS LONG, BYVAL ti AS STRING, _
                  BYVAL sound AS LONG, BYVAL x0 AS LONG, BYVAL y0 AS LONG, colr as long) AS LONG
   'nStyle = %MB_OK               for 1 button:  Ok
   '       = %MB_YESNO            for 2 buttons: Ok, Cancel
   '       = %MB_OKCANCEL         for 2 buttons: Yes, No
   '       = %MB_YESNOCANCEL      for 3 buttons: Yes, No, Cancel
   '       = %MB_ICONERROR        for error icon (stop sign)
   '       = %MB_ICONINFORMATION  for information icon
   '       = %MB_ICONQUESTION     for question icon
   '       = %MB_ICONWARNING      for warning icon
   'ti = title and sound = 1 for beep, x0, y0 = desktop location
   'Returns %IDOK, %IDYES, %IDNO, or %IDCANCEL
   'colr = color of text
   'Requires "WIN32API.INC"
   'Load this include file before myMsgbox is used
   '----------------------------------------------------------------------------                 
   LOCAL hMsgBox AS LONG, wi AS LONG, ht AS LONG, x AS LONG, y AS LONG
   LOCAL hParent AS LONG, hdc AS LONG, t AS SIZEL, w AS LONG, h AS LONG
   LOCAL hIcon AS LONG, s AS STRING , ss AS STRING
   LOCAL i AS LONG, m AS LONG, n AS LONG, k AS LONG, rc AS RECT
   local kolr as long
   
   if ismissing(colr) then kolr = 0 else kolr = colr
   hParent = GetActiveWindow
   DIALOG NEW PIXELS, hParent, ti, , , 200, 100 TO hMsgBox                                         
   DIALOG SET COLOR hMsgBox, -1, %WHITE '%LTGRAY
   'size the message box and add controls  -------------------------------------
   hdc = GetDc(hMsgbox)
   ss = msg: n = 1 'm = max text length, n = lines of text
   DO: i = INSTR(ss, $CRLF): s = ss
       IF i THEN s = LEFT$(ss, i - 1): INCR n                        
       GetTextExtentPoint32 hdc, BYVAL STRPTR(s), LEN(s), t
       ss = MID$(ss, i + 2): m = MAX(m, t.cx)
   LOOP UNTIL i = 0
   ReleaseDC hMsgBox, hdc
   IF nStyle > 6 THEN k = 50 ELSE k = 10                          
   CONTROL ADD LABEL, hMsgBox, 9990, msg, k, 5, m, 15*n
   CONTROL SET COLOR hMsgBox, 9990, kolr, %WHITE  '%LTGRAY  RGB(0, 0, 0)
   wi = MAX(220, m + k + 10): ht = MAX(120, 20*n + 55)
   m = nStyle MOD 16: n = ht - 70
   IF m = %MB_YESNOCANCEL THEN
      CONTROL ADD BUTTON, hMsgBox, 9991, "&Yes", 10, n, 60, 30, %BS_DEFAULT
      CONTROL ADD BUTTON, hMsgBox, 9992, "&No", 75, n, 60, 30
      CONTROL ADD BUTTON, hMsgBox, 9993, "Cancel", 140, n, 60, 30
      CONTROL SET FOCUS hMsgbox, 9991
   ELSEIF m = %MB_YESNO THEN
      CONTROL ADD BUTTON, hMsgBox, 9991, "&Yes", 10, n, 60, 30  ', %BS_DEFAULT
      CONTROL ADD BUTTON, hMsgBox, 9992, "&No", 75, n, 60, 30
   ELSEIF m = %MB_OKCANCEL THEN
      CONTROL ADD BUTTON, hMsgBox, 9991, "&Ok", 10, n, 60, 30, %BS_DEFAULT
      CONTROL ADD BUTTON, hMsgBox, 9992, "&Cancel", 75, n, 60, 30
   ELSE
      CONTROL ADD BUTTON, hMsgBox, 9994, "&Ok", 30, n, 80, 30, %BS_DEFAULT
   END IF
   'default location of msgbox -------------------------------------------------
   IF hParent THEN
      GetWindowRect hParent, rc: x = rc.nLeft: y = rc.nTop
      w = rc.nRight - rc.nLeft: h = rc.nBottom - rc.nTop
   ELSE
      DESKTOP GET CLIENT TO w, h
   END IF
   IF x0 OR y0 THEN
      x = MAX(x0, 0): y = MAX(y0, 0)
   ELSE
      x = x + (w - wi)/2: y = y + (h - ht)/2
   END IF
   MoveWindow hMsgbox, x, y, wi, ht, %TRUE
   'add icon to msgbox ---------------------------------------------------------
   CONTROL ADD LABEL, hMsgBox, 9995, "", 10, 5, 0, 0, %SS_ICON          
   CONTROL SET COLOR hMsgBox, 9995, RGB(0, 0, 0), %WHITE  '%LTGRAY
   k = %MB_OK: m = nStyle - m
   IF m = %MB_ICONERROR THEN
      n = 103: k = %MB_ICONHAND
   ELSEIF m = %MB_ICONQUESTION THEN
      n = 102: k = %MB_ICONQUESTION
   ELSEIF m = %MB_ICONWARNING THEN
      n = 101: k = %MB_ICONEXCLAMATION
   ELSEIF m = %MB_ICONINFORMATION THEN
      n = 104: k = %MB_ICONASTERISK
   END IF
   'hIcon = LoadImage(BYVAL 0, BYVAL n, %IMAGE_ICON, 32, 32, 0)
   'SendDlgItemMessage hMsgBox, 9995, %STM_SETIMAGE, %IMAGE_ICON, hIcon
'   DIALOG SEND hDlg, %WM_SETICON, 0, hIcon

   '----------------------------------------------------------------------------
   myMsgBoxReturn = 0
   IF sound THEN MessageBeep k
   DIALOG SHOW MODAL hMsgbox, CALL myMsgBoxProc
   FUNCTION = myMsgBoxReturn
END FUNCTION

CALLBACK FUNCTION myMsgBoxProc()
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL SEND CBHNDL, 9991, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
         SetWindowPos CBHNDL, %HWND_TOPMOST, 0,0,0,0, %SWP_NOMOVE OR %SWP_NOSIZE
      CASE %WM_COMMAND
         SELECT CASE CBCTL
         CASE 9991, %IDOK
            myMsgboxReturn = %IDYES
         CASE 9992, %IDCANCEL
            myMsgboxReturn = %IDNO
         CASE 9993
            myMsgboxReturn = %IDCANCEL
         CASE 9994
            myMsgboxReturn = %IDOK
         END SELECT
         DIALOG END CBHNDL
   END SELECT
END FUNCTION

SUB TestResults()
   LOCAL hResults, nStyle, wi, ht AS LONG
   LOCAL ti, s AS STRING
   ti = "Test" + STR$(numTests) + " Results": wi = 240: ht = 340
   DIALOG NEW PIXELS, hMain, ti, , , wi, ht, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hResults
   s = "Percent correct = " + FORMAT$(correct / numProbs * 100, fmt) + $CRLF + _
       STR$(correct) + " Correct out of" + STR$(numProbs)
   CONTROL ADD LABEL, hResults, -1, s, 10, 10, 200, 50
   CONTROL ADD LABEL, hResults, -1, "Problems with wrong answers:", 10, 70, 200, 20
   nStyle = %WS_TABSTOP OR %WS_VSCROLL OR %LBS_DISABLENOSCROLL
   CONTROL ADD LISTBOX, hResults, %IDC_Mistakes, , 20, 90, 200, 200, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hResults, -1, "Ans:", 20, ht - 35, 30, 20
   CONTROL ADD TEXTBOX, hResults, %IDC_CorrectAns, "", 50, ht - 35, 40, 20, %ES_READONLY, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hResults, %IDOK, "&Ok", wi - 100, ht - 40, 80, 30, %BS_DEFPUSHBUTTON
   DIALOG SHOW MODAL hResults CALL testResultsProc
END SUB                                              

CALLBACK FUNCTION testResultsProc()
   LOCAL i, n AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         LISTBOX RESET CB.HNDL, %IDC_Mistakes
         n = UBOUND(mistakes)
         FOR i = 1 TO n
            LISTBOX ADD CB.HNDL, %IDC_Mistakes, mistakes(i)
         NEXT i
      CASE %WM_COMMAND
         IF CB.CTL = %IDOK OR CB.CTL = %IDCANCEL THEN
            DIALOG END CB.HNDL                                             
         ELSEIF CB.CTL = %IDC_Mistakes AND CB.CTLMSG = %LBN_SELCHANGE THEN
            LISTBOX GET SELECT CB.HNDL, CB.CTL TO n
            CONTROL SET TEXT CB.HNDL, %IDC_CorrectAns, correctAns(n)
         END IF
   END SELECT
END FUNCTION
